<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListChangeQueue StructType
 * @subpackage Structs
 */
class ListChangeQueue extends AbstractStructBase
{
    /**
     * The firstChangeId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $firstChangeId;
    /**
     * The lastChangeId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $lastChangeId;
    /**
     * The nextStartChangeId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $nextStartChangeId;
    /**
     * The queueId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $queueId;
    /**
     * Constructor method for ListChangeQueue
     * @uses ListChangeQueue::setFirstChangeId()
     * @uses ListChangeQueue::setLastChangeId()
     * @uses ListChangeQueue::setNextStartChangeId()
     * @uses ListChangeQueue::setQueueId()
     * @param int $firstChangeId
     * @param int $lastChangeId
     * @param int $nextStartChangeId
     * @param string $queueId
     */
    public function __construct($firstChangeId = null, $lastChangeId = null, $nextStartChangeId = null, $queueId = null)
    {
        $this
            ->setFirstChangeId($firstChangeId)
            ->setLastChangeId($lastChangeId)
            ->setNextStartChangeId($nextStartChangeId)
            ->setQueueId($queueId);
    }
    /**
     * Get firstChangeId value
     * @return int|null
     */
    public function getFirstChangeId()
    {
        return $this->firstChangeId;
    }
    /**
     * Set firstChangeId value
     * @param int $firstChangeId
     * @return ListChangeQueue
     */
    public function setFirstChangeId($firstChangeId = null)
    {
        // validation for constraint: int
        if (!is_null($firstChangeId) && !is_numeric($firstChangeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($firstChangeId)), __LINE__);
        }
        $this->firstChangeId = $firstChangeId;
        return $this;
    }
    /**
     * Get lastChangeId value
     * @return int|null
     */
    public function getLastChangeId()
    {
        return $this->lastChangeId;
    }
    /**
     * Set lastChangeId value
     * @param int $lastChangeId
     * @return ListChangeQueue
     */
    public function setLastChangeId($lastChangeId = null)
    {
        // validation for constraint: int
        if (!is_null($lastChangeId) && !is_numeric($lastChangeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($lastChangeId)), __LINE__);
        }
        $this->lastChangeId = $lastChangeId;
        return $this;
    }
    /**
     * Get nextStartChangeId value
     * @return int|null
     */
    public function getNextStartChangeId()
    {
        return $this->nextStartChangeId;
    }
    /**
     * Set nextStartChangeId value
     * @param int $nextStartChangeId
     * @return ListChangeQueue
     */
    public function setNextStartChangeId($nextStartChangeId = null)
    {
        // validation for constraint: int
        if (!is_null($nextStartChangeId) && !is_numeric($nextStartChangeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($nextStartChangeId)), __LINE__);
        }
        $this->nextStartChangeId = $nextStartChangeId;
        return $this;
    }
    /**
     * Get queueId value
     * @return string|null
     */
    public function getQueueId()
    {
        return $this->queueId;
    }
    /**
     * Set queueId value
     * @param string $queueId
     * @return ListChangeQueue
     */
    public function setQueueId($queueId = null)
    {
        // validation for constraint: string
        if (!is_null($queueId) && !is_string($queueId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($queueId)), __LINE__);
        }
        $this->queueId = $queueId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return ListChangeQueue
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
